<?php
class ControllerExtensionPaymentIpasspayhost extends Controller {
    private $error = array();

    public function index() {
        $this->load->language('extension/payment/ipasspayhost');

        $this->document->setTitle($this->language->get('heading_title'));

        $this->load->model('setting/setting');

        if (($this->request->server['REQUEST_METHOD'] == 'POST') && $this->validate()) {
            $this->model_setting_setting->editSetting('payment_ipasspayhost', $this->request->post);

            $this->session->data['success'] = $this->language->get('text_success');

            $this->response->redirect($this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true));
        }

        if (isset($this->error['warning'])) {
            $data['error_warning'] = $this->error['warning'];
        } else {
            $data['error_warning'] = '';
        }

        if (isset($this->error['vendor'])) {
            $data['error_vendor'] = $this->error['vendor'];
        } else {
            $data['error_vendor'] = '';
        }

        $data['breadcrumbs'] = array();

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_home'),
            'href' => $this->url->link('common/dashboard', 'user_token=' . $this->session->data['user_token'], true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('text_extension'),
            'href' => $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true)
        );

        $data['breadcrumbs'][] = array(
            'text' => $this->language->get('heading_title'),
            'href' => $this->url->link('extension/payment/ipasspayhost', 'user_token=' . $this->session->data['user_token'], true)
        );

        $data['action'] = $this->url->link('extension/payment/ipasspayhost', 'user_token=' . $this->session->data['user_token'], true);

        $data['cancel'] = $this->url->link('marketplace/extension', 'user_token=' . $this->session->data['user_token'] . '&type=payment', true);

        //merchantid
        if (isset($this->request->post['payment_ipasspayhost_vendor'])) {
            $data['payment_ipasspayhost_vendor'] = $this->request->post['payment_ipasspayhost_vendor'];
        } else {
            $data['payment_ipasspayhost_vendor'] = $this->config->get('payment_ipasspayhost_vendor');
        }

        //siteid
        if (isset($this->request->post['payment_ipasspayhost_site'])) {
            $data['payment_ipasspayhost_site'] = $this->request->post['payment_ipasspayhost_site'];
        } else {
            $data['payment_ipasspayhost_site'] = $this->config->get('payment_ipasspayhost_site');
        }

        //apikey
        if (isset($this->request->post['payment_ipasspayhost_cron_job_token'])) {
            $data['payment_ipasspayhost_cron_job_token'] = $this->request->post['payment_ipasspayhost_cron_job_token'];
        } else {
            $data['payment_ipasspayhost_cron_job_token'] = $this->config->get('payment_ipasspayhost_cron_job_token');
        }

        //gateway version
        if (isset($this->request->post['payment_ipasspayhost_gateway_version'])) {
            $data['payment_ipasspayhost_gateway_version'] = $this->request->post['payment_ipasspayhost_gateway_version'];
        } else {
            $data['payment_ipasspayhost_gateway_version'] = $this->config->get('payment_ipasspayhost_gateway_version');
        }

        //gateway url
        if (isset($this->request->post['payment_ipasspayhost_gateway_url'])) {
            $data['payment_ipasspayhost_gateway_url'] = $this->request->post['payment_ipasspayhost_gateway_url'];
        } else {
            $data['payment_ipasspayhost_gateway_url'] = $this->config->get('payment_ipasspayhost_gateway_url');
        }

        //notify url
        /*
        if (isset($this->request->post['payment_ipasspayhost_noitfy_url'])) {
            $data['payment_ipasspayhost_noitfy_url'] = $this->request->post['payment_ipasspayhost_noitfy_url'];
        } else {
            $data['payment_ipasspayhost_noitfy_url'] = $this->config->get('payment_ipasspayhost_noitfy_url');
        }*/

        if (isset($this->request->post['payment_ipasspayhost_password'])) {
            $data['payment_ipasspayhost_password'] = $this->request->post['payment_ipasspayhost_password'];
        } else {
            $data['payment_ipasspayhost_password'] = $this->config->get('payment_ipasspayhost_password');
        }

        if (isset($this->request->post['payment_ipasspayhost_test'])) {
            $data['payment_ipasspayhost_test'] = $this->request->post['payment_ipasspayhost_test'];
        } else {
            $data['payment_ipasspayhost_test'] = $this->config->get('payment_ipasspayhost_test');
        }

        if (isset($this->request->post['payment_ipasspayhost_transaction'])) {
            $data['payment_ipasspayhost_transaction'] = $this->request->post['payment_ipasspayhost_transaction'];
        } else {
            $data['payment_ipasspayhost_transaction'] = $this->config->get('payment_ipasspayhost_transaction');
        }

        if (isset($this->request->post['payment_ipasspayhost_total'])) {
            $data['payment_ipasspayhost_total'] = $this->request->post['payment_ipasspayhost_total'];
        } else {
            $data['payment_ipasspayhost_total'] = $this->config->get('payment_ipasspayhost_total');
        }

        if (isset($this->request->post['payment_ipasspayhost_card'])) {
            $data['payment_ipasspayhost_card'] = $this->request->post['payment_ipasspayhost_card'];
        } else {
            $data['payment_ipasspayhost_card'] = $this->config->get('payment_ipasspayhost_card');
        }

        //pending order status
        if (isset($this->request->post['payment_ipasspayhost_order_status_id'])) {
            $data['payment_ipasspayhost_order_status_id'] = $this->request->post['payment_ipasspayhost_order_status_id'];
        } else {
            $data['payment_ipasspayhost_order_status_id'] = $this->config->get('payment_ipasspayhost_order_status_id');
        }

        //success order status
        if (isset($this->request->post['payment_ipasspayhost_order_status_id_success'])) {
            $data['payment_ipasspayhost_order_status_id_success'] = $this->request->post['payment_ipasspayhost_order_status_id_success'];
        } else {
            $data['payment_ipasspayhost_order_status_id_success'] = $this->config->get('payment_ipasspayhost_order_status_id_success');
        }

        // failure order status
        if (isset($this->request->post['payment_ipasspayhost_order_status_id_failure'])) {
            $data['payment_ipasspayhost_order_status_id_failure'] = $this->request->post['payment_ipasspayhost_order_status_id_failure'];
        } else {
            $data['payment_ipasspayhost_order_status_id_failure'] = $this->config->get('payment_ipasspayhost_order_status_id_failure');
        }

        $this->load->model('localisation/order_status');

        $data['order_statuses'] = $this->model_localisation_order_status->getOrderStatuses();

        if (isset($this->request->post['payment_ipasspayhost_geo_zone_id'])) {
            $data['payment_ipasspayhost_geo_zone_id'] = $this->request->post['payment_ipasspayhost_geo_zone_id'];
        } else {
            $data['payment_ipasspayhost_geo_zone_id'] = $this->config->get('payment_ipasspayhost_geo_zone_id');
        }

        $this->load->model('localisation/geo_zone');

        $data['geo_zones'] = $this->model_localisation_geo_zone->getGeoZones();

        if (isset($this->request->post['payment_ipasspayhost_status'])) {
            $data['payment_ipasspayhost_status'] = $this->request->post['payment_ipasspayhost_status'];
        } else {
            $data['payment_ipasspayhost_status'] = $this->config->get('payment_ipasspayhost_status');
        }

        if (isset($this->request->post['payment_ipasspayhost_debug'])) {
            $data['payment_ipasspayhost_debug'] = $this->request->post['payment_ipasspayhost_debug'];
        } else {
            $data['payment_ipasspayhost_debug'] = $this->config->get('payment_ipasspayhost_debug');
        }

        if (isset($this->request->post['payment_ipasspayhost_sort_order'])) {
            $data['payment_ipasspayhost_sort_order'] = $this->request->post['payment_ipasspayhost_sort_order'];
        } else {
            $data['payment_ipasspayhost_sort_order'] = $this->config->get('payment_ipasspayhost_sort_order');
        }

        if (isset($this->request->post['payment_ipasspayhost_cron_job_token'])) {
            $data['payment_ipasspayhost_cron_job_token'] = $this->request->post['payment_ipasspayhost_cron_job_token'];
        } elseif ($this->config->get('payment_ipasspayhost_cron_job_token')) {
            $data['payment_ipasspayhost_cron_job_token'] = $this->config->get('payment_ipasspayhost_cron_job_token');
        } else {
            $data['payment_ipasspayhost_cron_job_token'] = sha1(uniqid(mt_rand(), 1));
        }

        $data['ipasspayhost_cron_job_url'] = HTTPS_CATALOG . 'index.php?route=extension/payment/ipasspayhost/cron&token=' . $data['payment_ipasspayhost_cron_job_token'];

        if ($this->config->get('payment_ipasspayhost_last_cron_job_run')) {
            $data['payment_ipasspayhost_last_cron_job_run'] = $this->config->get('payment_ipasspayhost_last_cron_job_run');
        } else {
            $data['payment_ipasspayhost_last_cron_job_run'] = '';
        }

        $data['header'] = $this->load->controller('common/header');
        $data['column_left'] = $this->load->controller('common/column_left');
        $data['footer'] = $this->load->controller('common/footer');

        $this->response->setOutput($this->load->view('extension/payment/ipasspayhost', $data));
    }

    public function install() {
        $this->load->model('extension/payment/ipasspayhost');
        $this->model_extension_payment_ipasspayhost->install();
    }

    public function uninstall() {
        $this->load->model('extension/payment/ipasspayhost');
        $this->model_extension_payment_ipasspayhost->uninstall();
    }

    public function order() {
        if ($this->config->get('payment_ipasspayhost_status')) {
            $this->load->model('extension/payment/ipasspayhost');

            $ipasspayhost_order = $this->model_extension_payment_ipasspayhost->getOrder($this->request->get['order_id']);

            if (!empty($ipasspayhost_order)) {
                $this->load->language('extension/payment/ipasspayhost');

                $ipasspayhost_order['total_released'] = $this->model_extension_payment_ipasspayhost->getTotalReleased($ipasspayhost_order['ipasspayhost_order_id']);

                $ipasspayhost_order['total_formatted'] = $this->currency->format($ipasspayhost_order['total'], $ipasspayhost_order['currency_code'], false, false);
                $ipasspayhost_order['total_released_formatted'] = $this->currency->format($ipasspayhost_order['total_released'], $ipasspayhost_order['currency_code'], false, false);

                $data['ipasspayhost_order'] = $ipasspayhost_order;

                $data['auto_settle'] = $ipasspayhost_order['settle_type'];

                $data['order_id'] = $this->request->get['order_id'];

                $data['user_token'] = $this->request->get['user_token'];

                return $this->load->view('extension/payment/ipasspayhost_order', $data);
            }
        }
    }

    public function void() {
        $this->load->language('extension/payment/ipasspayhost');
        $json = array();

        if (isset($this->request->post['order_id']) && $this->request->post['order_id'] != '') {
            $this->load->model('extension/payment/ipasspayhost');

            $ipasspayhost_order = $this->model_extension_payment_ipasspayhost->getOrder($this->request->post['order_id']);

            $void_response = $this->model_extension_payment_ipasspayhost->void($this->request->post['order_id']);

            $this->model_extension_payment_ipasspayhost->logger('Void result', $void_response);

            if ($void_response['Status'] == 'OK') {
                $this->model_extension_payment_ipasspayhost->addTransaction($ipasspayhost_order['ipasspayhost_order_id'], 'void', 0.00);
                $this->model_extension_payment_ipasspayhost->updateVoidStatus($ipasspayhost_order['ipasspayhost_order_id'], 1);

                $json['msg'] = $this->language->get('text_void_ok');

                $json['data'] = array();
                $json['data']['date_added'] = date("Y-m-d H:i:s");
                $json['error'] = false;
            } else {
                $json['error'] = true;
                $json['msg'] = isset($void_response['StatuesDetail']) && !empty($void_response['StatuesDetail']) ? (string)$void_response['StatuesDetail'] : 'Unable to void';
            }
        } else {
            $json['error'] = true;
            $json['msg'] = 'Missing data';
        }

        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($json));
    }

    public function release() {
        $this->load->language('extension/payment/ipasspayhost');
        $json = array();

        if (isset($this->request->post['order_id']) && $this->request->post['order_id'] != '' && isset($this->request->post['amount']) && $this->request->post['amount'] > 0) {
            $this->load->model('extension/payment/ipasspayhost');

            $ipasspayhost_order = $this->model_extension_payment_ipasspayhost->getOrder($this->request->post['order_id']);

            $release_response = $this->model_extension_payment_ipasspayhost->release($this->request->post['order_id'], $this->request->post['amount']);

            $this->model_extension_payment_ipasspayhost->logger('Release result', $release_response);

            if ($release_response['Status'] == 'OK') {
                $this->model_extension_payment_ipasspayhost->addTransaction($ipasspayhost_order['ipasspayhost_order_id'], 'payment', $this->request->post['amount']);

                $total_released = $this->model_extension_payment_ipasspayhost->getTotalReleased($ipasspayhost_order['ipasspayhost_order_id']);

                if ($total_released >= $ipasspayhost_order['total'] || $ipasspayhost_order['settle_type'] == 0) {
                    $this->model_extension_payment_ipasspayhost->updateReleaseStatus($ipasspayhost_order['ipasspayhost_order_id'], 1);
                    $release_status = 1;
                    $json['msg'] = $this->language->get('text_release_ok_order');
                } else {
                    $release_status = 0;
                    $json['msg'] = $this->language->get('text_release_ok');
                }

                $json['data'] = array();
                $json['data']['date_added'] = date("Y-m-d H:i:s");
                $json['data']['amount'] = $this->request->post['amount'];
                $json['data']['release_status'] = $release_status;
                $json['data']['total'] = (float)$total_released;
                $json['error'] = false;
            } else {
                $json['error'] = true;
                $json['msg'] = isset($release_response['StatusDetail']) && !empty($release_response['StatusDetail']) ? (string)$release_response['StatusDetail'] : 'Unable to release';
            }
        } else {
            $json['error'] = true;
            $json['msg'] = $this->language->get('error_data_missing');
        }

        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($json));
    }

    public function rebate() {
        $this->load->language('extension/payment/ipasspayhost');
        $json = array();

        if (isset($this->request->post['order_id']) && !empty($this->request->post['order_id'])) {
            $this->load->model('extension/payment/ipasspayhost');

            $ipasspayhost_order = $this->model_extension_payment_ipasspayhost->getOrder($this->request->post['order_id']);

            $rebate_response = $this->model_extension_payment_ipasspayhost->rebate($this->request->post['order_id'], $this->request->post['amount']);

            $this->model_extension_payment_ipasspayhost->logger('Rebate result', $rebate_response);

            if ($rebate_response['Status'] == 'OK') {
                $this->model_extension_payment_ipasspayhost->addTransaction($ipasspayhost_order['ipasspayhost_order_id'], 'rebate', $this->request->post['amount'] * -1);

                $total_rebated = $this->model_extension_payment_ipasspayhost->getTotalRebated($ipasspayhost_order['ipasspayhost_order_id']);
                $total_released = $this->model_extension_payment_ipasspayhost->getTotalReleased($ipasspayhost_order['ipasspayhost_order_id']);

                if ($total_released <= 0 && $ipasspayhost_order['release_status'] == 1) {
                    $this->model_extension_payment_ipasspayhost->updateRebateStatus($ipasspayhost_order['ipasspayhost_order_id'], 1);
                    $rebate_status = 1;
                    $json['msg'] = $this->language->get('text_rebate_ok_order');
                } else {
                    $rebate_status = 0;
                    $json['msg'] = $this->language->get('text_rebate_ok');
                }

                $json['data'] = array();
                $json['data']['date_added'] = date("Y-m-d H:i:s");
                $json['data']['amount'] = $this->request->post['amount'] * -1;
                $json['data']['total_released'] = (float)$total_released;
                $json['data']['total_rebated'] = (float)$total_rebated;
                $json['data']['rebate_status'] = $rebate_status;
                $json['error'] = false;
            } else {
                $json['error'] = true;
                $json['msg'] = isset($rebate_response['StatusDetail']) && !empty($rebate_response['StatusDetail']) ? (string)$rebate_response['StatusDetail'] : 'Unable to rebate';
            }
        } else {
            $json['error'] = true;
            $json['msg'] = 'Missing data';
        }

        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($json));
    }

    protected function validate() {
        if (!$this->user->hasPermission('modify', 'extension/payment/ipasspayhost')) {
            $this->error['warning'] = $this->language->get('error_permission');
        }

        if (!$this->request->post['payment_ipasspayhost_vendor']) {
            $this->error['vendor'] = $this->language->get('error_vendor');
        }

        return !$this->error;
    }
}
