<?php
class ControllerExtensionPaymentIpasspayhost extends Controller {
    public function index() {
        $this->load->language('extension/payment/ipasspayhost');

        if (isset($this->session->data['success'])) {
            $data['success'] = $this->session->data['success'];
            unset($this->session->data['success']);
        } else {
            $data['success'] = '';
        }

        $data['cards'] = array();

        $data['cards'][] = array(
            'text' => 'Visa',
            'value' => 'VISA'
        );

        $data['cards'][] = array(
            'text' => 'MasterCard',
            'value' => 'MC'
        );

        $data['cards'][] = array(
            'text' => 'Visa Delta/Debit',
            'value' => 'DELTA'
        );

        $data['cards'][] = array(
            'text' => 'Solo',
            'value' => 'SOLO'
        );

        $data['cards'][] = array(
            'text' => 'Maestro',
            'value' => 'MAESTRO'
        );

        $data['cards'][] = array(
            'text' => 'Visa Electron UK Debit',
            'value' => 'UKE'
        );

        $data['cards'][] = array(
            'text' => 'American Express',
            'value' => 'AMEX'
        );

        $data['cards'][] = array(
            'text' => 'Diners Club',
            'value' => 'DC'
        );

        $data['cards'][] = array(
            'text' => 'Japan Credit Bureau',
            'value' => 'JCB'
        );

        $data['months'] = array();

        for ($i = 1; $i <= 12; $i++) {
            $data['months'][] = array(
                'text' => strftime('%B', mktime(0, 0, 0, $i, 1, 2000)),
                'value' => sprintf('%02d', $i)
            );
        }

        $today = getdate();

        $data['year_valid'] = array();

        for ($i = $today['year'] - 10; $i < $today['year'] + 1; $i++) {
            $data['year_valid'][] = array(
                'text' => strftime('%Y', mktime(0, 0, 0, 1, 1, $i)),
                'value' => strftime('%Y', mktime(0, 0, 0, 1, 1, $i))
            );
        }

        $data['year_expire'] = array();

        for ($i = $today['year']; $i < $today['year'] + 11; $i++) {
            $data['year_expire'][] = array(
                'text' => strftime('%Y', mktime(0, 0, 0, 1, 1, $i)),
                'value' => strftime('%Y', mktime(0, 0, 0, 1, 1, $i))
            );
        }

        if ($this->config->get('payment_ipasspayhost_card') == '1') {
            $data['ipasspayhost_card'] = true;
        } else {
            $data['ipasspayhost_card'] = false;
        }

        $data['existing_cards'] = array();
        if ($this->customer->isLogged() && $data['ipasspayhost_card']) {
            $this->load->model('extension/payment/ipasspayhost');
            $data['existing_cards'] = $this->model_extension_payment_ipasspayhost->getCards($this->customer->getId());
        }

        return $this->load->view('extension/payment/ipasspayhost', $data);
    }

    public function send() {
        $this->load->language('extension/payment/ipasspayhost');
        $this->load->model('checkout/order');
        $this->load->model('extension/payment/ipasspayhost');
        $this->load->model('account/order');

        $order_info = $this->model_checkout_order->getOrder($this->session->data['order_id']);
        $gateway_url = $this->config->get('payment_ipasspayhost_gateway_url');
        $api_secret = $this->config->get('payment_ipasspayhost_cron_job_token');
        $order_id = $this->session->data['order_id'];

        //收集卡支付信息
        //$curlPost['card_no'] = $this->request->post['cc_number'];
        //$curlPost['card_ex_year'] = substr($this->request->post['cc_expire_date_year'], 2);
        //$curlPost['card_ex_month'] = $this->request->post['cc_expire_date_month'];
        //$curlPost['card_cvv'] = $this->request->post['cc_cvv2'];

        $curlPost['merchant_id'] = $this->config->get('payment_ipasspayhost_vendor');
        $curlPost['app_id'] = $this->config->get('payment_ipasspayhost_site');
        $curlPost['order_no'] = time()."opencart".$order_id;
        $curlPost['order_currency'] =  $this->session->data['currency'];
        $curlPost['order_amount'] = sprintf("%.2f",$this->currency->format($order_info['total'], $order_info['currency_code'], false, false));
        $curlPost['order_items'] = 'goods';
        $curlPost['source_ip'] = ($this->getIP()=='::1')?'127.0.0.1':$this->getIP();
        $curlPost['source_url'] = $this->curPageURL();
        $curlPost['asyn_notify_url'] =  $this->url->link('extension/payment/ipasspayhost/callback', '', true);
        $curlPost['syn_notify_url'] = $this->curPageURL();
        $curlPost['version'] =  $this->config->get('payment_ipasspayhost_gateway_version');
        $curlPost['signature'] = hash('sha256', $curlPost['merchant_id'] . $curlPost['app_id']  . $curlPost['order_no'] . $curlPost['order_amount'] . $curlPost['order_currency'] . $api_secret);

        $curlPost['bill_firstname'] =  $order_info['payment_firstname'];
        $curlPost['bill_lastname'] =  $order_info['payment_lastname'];
        $curlPost['bill_email'] =  $order_info['email'];
        $curlPost['bill_phone'] = $order_info['telephone'];
        $curlPost['bill_country'] = $order_info['payment_iso_code_2'];
        $curlPost['bill_state'] = $order_info['payment_zone_code'];
        $curlPost['bill_city'] = $order_info['payment_city'];
        $curlPost['bill_street'] = $order_info['payment_address_1'];
        $curlPost['bill_zip'] = $order_info['payment_postcode'];

        $curlPost['ship_firstname'] = $order_info['shipping_firstname'];
        $curlPost['ship_lastname'] = $order_info['shipping_lastname'];
        $curlPost['ship_email'] = $order_info['email'];
        $curlPost['ship_phone'] = $order_info['telephone'];
        $curlPost['ship_country'] = $order_info['shipping_iso_code_2'];
        $curlPost['ship_state'] = $order_info['shipping_zone_code'];
        $curlPost['ship_city'] = $order_info['shipping_city'];
        $curlPost['ship_street'] = $order_info['shipping_address_1'];
        $curlPost['ship_zip'] = $order_info['shipping_postcode'];
        $curlPost['custom_data'] = $order_id;
        $curlPost['lang'] = 'en-us'; //zh-cn en-us
        //echo $curlPost['order_no'];exit;
        //$response = $this->curlSend($gateway_url,$curlPost,1);
        //echo $response;exit;

        $curlPost = http_build_query($curlPost);
        $gateway_host_url = $gateway_url."?".$curlPost;

        $message = "Payment processing";
        $this->model_checkout_order->addOrderHistory($this->session->data['order_id'], $this->config->get('payment_ipasspayhost_order_status_id'), $message, false);
        //$json['error'] = "";
        $json['redirect'] = $gateway_host_url;
        $this->cart->clear();

        $this->response->addHeader('Content-Type: application/json');
        $this->response->setOutput(json_encode($json));
    }

    public function callback() {

        $this->load->model('extension/payment/ipasspayhost');
        $this->load->language('extension/payment/ipasspayhost');
        $this->load->model('checkout/order');

        $merchant_id = $this->config->get('payment_ipasspayhost_vendor');
        $app_id = $this->config->get('payment_ipasspayhost_site');
        $api_secret =  $this->config->get('payment_ipasspayhost_cron_job_token');

        $order_id = $_REQUEST['custom_data'];
        $order_no = $_REQUEST['order_no'];
        $gateway_order_no = $_REQUEST['gateway_order_no'];
        $order_currency = $_REQUEST['order_currency'];
        $order_amount = $_REQUEST['order_amount'];
        $order_status = $_REQUEST['order_status'];
        $order_signature = $_REQUEST['signature'];

        /*
                $order_id = '18';
                $order_no = '18';
                $gateway_order_no ='18';
                $order_currency ='18';
                $order_amount = '18';
                $order_status ='3';
                $order_signature ='18';
        */
        $signature = hash('sha256', $merchant_id.$app_id.$order_no.
            $gateway_order_no.$order_currency.$order_amount.
            $order_status.$api_secret);

        //验签
        if ($signature == $order_signature) {
            switch ($order_status) {
                case '2':
                    $message = "Payment success";
                    $this->model_checkout_order->addOrderHistory($order_id, $this->config->get('payment_ipasspayhost_order_status_id_success'), $message, false);
                    break;
                case '3': //失败
                    $message = "Payment failure";
                    $this->model_checkout_order->addOrderHistory($order_id, $this->config->get('payment_ipasspayhost_order_status_id_failure'), $message, false);
                    break;
                default:
                    break;
            }
            $res = array(
                'errcode' => '0',
                'errmsg' => 'success'
            );
        } else {
            $res = array(
                'errcode' => '1',
                'errmsg' => 'failure'
            );
        }

        echo json_encode($res);
        exit;

    }

    public function delete() {

        $this->load->language('account/ipasspayhost_cards');

        $this->load->model('extension/payment/ipasspayhost');

        $card = $this->model_extension_payment_ipasspayhost->getCard(false, $this->request->post['Token']);

        if (!empty($card['token'])) {
            if ($this->config->get('payment_ipasspayhost_test') == 'live') {
                $url = 'https://live.ipasspay.com/gateway/service/removetoken.vsp';
            } else {
                $url = 'https://test.ipasspay.com/gateway/service/removetoken.vsp';
            }
            $payment_data['VPSProtocol'] = '3.00';
            $payment_data['Vendor'] = $this->config->get('payment_ipasspayhost_vendor');
            $payment_data['TxType'] = 'REMOVETOKEN';
            $payment_data['Token'] = $card['token'];

            $response_data = $this->model_extension_payment_ipasspayhost->sendCurl($url, $payment_data);
            if ($response_data['Status'] == 'OK') {
                $this->model_extension_payment_ipasspayhost->deleteCard($card['card_id']);
                $this->session->data['success'] = $this->language->get('text_success_card');
                $json['success'] = true;
            } else {
                $json['error'] = $this->language->get('text_fail_card');
            }
        } else {
            $json['error'] = $this->language->get('text_fail_card');
        }
        $this->response->setOutput(json_encode($json));
    }

    public function cron() {
        if (isset($this->request->get['token']) && hash_equals($this->config->get('payment_ipasspayhost_cron_job_token'), $this->request->get['token'])) {
            $this->load->model('extension/payment/ipasspayhost');

            $orders = $this->model_extension_payment_ipasspayhost->cronPayment();

            $this->model_extension_payment_ipasspayhost->updateCronJobRunTime();

            $this->model_extension_payment_ipasspayhost->logger('Repeat Orders', $orders);
        }
    }

    public function getIP()
    {
        static $realip;
        if (isset($_SERVER)){
            if (isset($_SERVER["HTTP_X_FORWARDED_FOR"])){
                $realip = $_SERVER["HTTP_X_FORWARDED_FOR"];
            } else if (isset($_SERVER["HTTP_CLIENT_IP"])) {
                $realip = $_SERVER["HTTP_CLIENT_IP"];
            } else {
                $realip = $_SERVER["REMOTE_ADDR"];
            }
        } else {
            if (getenv("HTTP_X_FORWARDED_FOR")){
                $realip = getenv("HTTP_X_FORWARDED_FOR");
            } else if (getenv("HTTP_CLIENT_IP")) {
                $realip = getenv("HTTP_CLIENT_IP");
            } else {
                $realip = getenv("REMOTE_ADDR");
            }
        }
        return $realip;
    }

    public function curPageURL()
    {
        $pageURL = 'http';

        if ($_SERVER["HTTPS"] == "on")
        {
            $pageURL .= "s";
        }
        $pageURL .= "://";

        if ($_SERVER["SERVER_PORT"] != "80")
        {
            $pageURL .= $_SERVER["SERVER_NAME"] . ":" . $_SERVER["SERVER_PORT"];
        }
        else
        {
            $pageURL .= $_SERVER["SERVER_NAME"];
        }
        return $pageURL;
    }

    private function curlSend($process_gateway, $data_arr, $type = 1) {
        $ch = curl_init();
        curl_setopt($ch, CURLOPT_URL, $process_gateway);
        curl_setopt($ch, CURLOPT_POST, $type);
        curl_setopt($ch, CURLOPT_POSTFIELDS, http_build_query($data_arr));
        curl_setopt($ch, CURLOPT_RETURNTRANSFER, 1);
        curl_setopt($ch, CURLOPT_SSL_VERIFYPEER, false);
        curl_setopt($ch, CURLOPT_SSL_VERIFYHOST, false);
        $response = curl_exec($ch);
        curl_close($ch);
        return $response;
    }

}